<?php
/*
 * @component AlphaUserPoints
 * @copyright Copyright (C) 2008 Bernard Gilly
 * @license : GNU/GPL
 * @Website : http://www.alphaplug.com
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.controller' );

/**
 * @package AlphaUserPoints
 */
class alphauserpointsController extends JController
{
	/**
	 * Custom Constructor
	 */
 	function __construct()	{
		parent::__construct( );
	}	

	/**
	* Show Control Panel
	*/
	function cpanel() {
	
		$model          = &$this->getModel ( 'statistics' );
		$model2         = &$this->getModel ( 'requests' );
		$view  			= $this->getView ( 'cpanel','html');
		
		$_top10 	 	= $model->_load_top10 ();
		$_unapproved 	= $model->_load_unapproved ();
		$_needsync   	= $model->_needsync ();		
		$_requestslevel = $model2->_load_currentrequestschangelevel ();
		
		$view->assign('top10', $_top10 );
		$view->assign('unapproved10', $_unapproved[0] );
		$view->assign('totalunapproved', $_unapproved[1] );
		$view->assign('needSync', $_needsync );
		$view->assign('requestslevel', $_requestslevel[0] );
		$view->assign('totalrequestslevel', $_requestslevel[1] );
		$view->show();
	}	

	
	/**
	* Show About
	*/
	function about() {
		$view  = $this->getView ( 'about','html');		
		$view->show();
	}
	
	/**
	* Set max points for all users
	*/
	function setmaxpoints() {
		global $mainframe;	
		
		$view         = $this->getView  ( 'maxpoints','html' );	
		
		$setpoints	= JRequest::getVar( 'newmaxpoints', 0, 'get', 'int' );
		
		$view->assign('setpoints', $setpoints );
		$view->showform();
	
	}	
	
	function savemaxpoints() {
		global $mainframe;
		
		$model        = &$this->getModel ( 'users' );
		
		$view         = $this->getView  ( 'maxpoints','html' );		
		
		$_setmaxpoints = $model->_setmaxpoints ();
		
		$msg         = JText::_( 'AUP_NEWMAXPOINTS' ) . " " . $_setmaxpoints;
		$urlredirect = "index.php?option=com_alphauserpoints&task=setmaxpoints&newmaxpoints=$_setmaxpoints";
		$mainframe->redirect( $urlredirect, $msg );
	
	}
		
	function usersync() {
		global $mainframe;
		
		$model       = &$this->getModel ( 'users' );
		
		$_usersync   = $model->_setusersync ();	
		
		$num_new = ( $_usersync ) ? " (" . $_usersync . " " . JText::_( 'AUP_NEW' ) . ")" : "" ;
		
		$msg         = JText::_( 'AUP_ALLUSERSSYNC' ) . $num_new ;
		
		$urlredirect = "index.php?option=com_alphauserpoints&task=cpanel";
		$mainframe->redirect( $urlredirect, $msg );
	
	}
	
	function resetpoints() {
		global $mainframe;	
		
		$model       = &$this->getModel ( 'users' );
		
		$_resetpoints= $model->_resetpoints ();	
		
		$msg         = JText::_( 'AUP_SUCCESSFULLYRESETTOZERO' ) ;
		
		$urlredirect = "index.php?option=com_alphauserpoints&task=cpanel";
		$mainframe->redirect( $urlredirect, $msg );
	
	}
	
	function recalculate() {
		global $mainframe;
	
		$model       = &$this->getModel ( 'users' );
		
		$_recalculatepoints= $model->_recalculate_points ();	

		$mainframe->enqueueMessage( JText::_( 'AUP_SUCCESSFULLYRECALCULATE' ) );
		
		$urlredirect = "index.php?option=com_alphauserpoints&task=cpanel";
		$mainframe->redirect( $urlredirect );
				
	}
	
	function purge() {
		global $mainframe;
		
		$model       = &$this->getModel ( 'users' );
		
		$_purgeexpirepoints	= $model->_purge_expires ();
		
		$_recalculatepoints	= $model->_recalculate_points ();
		
		$msg         = JText::_( 'AUP_SUCCESSFULLYPURGE' ) ;
		
		$urlredirect = "index.php?option=com_alphauserpoints&task=cpanel";
		$mainframe->redirect( $urlredirect, $msg );
	}
	
	
	/**
	* Show Rules
	*/
	function rules() {
		global $mainframe;
		
		$model        = &$this->getModel ( 'rules' );
		$view         = $this->getView  ( 'rules','html' );

		// load rules
		$_rules = $model->_load_rules ();
		
		$view->assign('rules', $_rules[0] );
		$view->assign('total', $_rules[1] );
		$view->assign('limit', $_rules[2] );
		$view->assign('limitstart', $_rules[3] );		
		
		// Display
		$view->_displaylist();		
	}

	/**
	* Edit Rules
	*/
	function editrule() {	
		global $mainframe;
		
		$model        = &$this->getModel ( 'rules' );
		$view         = $this->getView  ( 'rules','html' );
		
		$_row = $model->_edit_rule ();
		
		$view->assign('row', $_row );
		
		// Display
		$view->_edit_rule();				
	}	
	
	
	/**
	* Savee Rule
	*/
	function saverule() {
		global $mainframe;
		
		$model        = &$this->getModel ( 'rules' );
		// save rule(s)
		$model->_save_rule ();	

	}	
	
	/**
	* Delete Rules
	*/
	function deleterule() {
		global $mainframe;
		
		$model        = &$this->getModel ( 'rules' );
		// delete rule(s)
		$model->_delete_rule ();	

	}	
	
	
	function cancelrule() {
		global $mainframe;
		
		$redirecturl = "index.php?option=com_alphauserpoints&task=rules";		
		$mainframe->redirect( $redirecturl );	
	
	}
	
	
	function copyrule() {
	
		$model        = &$this->getModel ( 'rules' );
		// delete rule(s)
		$model->_copy_rule ();	
	
	}
	
	function statistics() {
	
		$model        = &$this->getModel ( 'statistics' );
		$view         = $this->getView  ( 'statistics','html' );
		
		$_stats = $model->_load_users ();	
		
		$view->assign('usersStats', $_stats[0] );
		$view->assign('total', $_stats[1] );
		$view->assign('limit', $_stats[2] );
		$view->assign('limitstart', $_stats[3] );
		$view->assign('lists', $_stats[4] );
			
		
		// Display
		$view->_displaylist();	
	}
	
	function edituser () {
		global $mainframe;
		
		$model        = &$this->getModel ( 'statistics' );
		$view         = $this->getView  ( 'statistics','html' );
		
		$_row = $model->_edit_user ();
		
		$view->assign('row', $_row );
		
		// Display
		$view->_edit_user();			
	
	
	}
	
	function saveuser() {
		global $mainframe;
		
		$model        = &$this->getModel ( 'statistics' );
		// save general user stats
		$model->_save_user ();	

	}	

	function canceluser(){
		global $mainframe;
		
		$redirecturl = "index.php?option=com_alphauserpoints&task=statistics";		
		$mainframe->redirect( $redirecturl );		
	}
	
	function showdetails() {
	
		$_name		= JRequest::getVar( 'name', '', 'get', 'string' );
	
		$model = &$this->getModel ( 'user' );
		$view  = $this->getView ( 'user','html');
		
		// load user details
		$userDetails = $model->_load_details_user ();
		
		$view->assign('userDetails', $userDetails[0] );
		$view->assign('total', $userDetails[1] );
		$view->assign('limit', $userDetails[2] );
		$view->assign('limitstart', $userDetails[3] );
		$view->assign('lists', $userDetails[4] );
		$view->assign('name', $_name );
		
		// Display
		$view->_displaylist();		

	}
		
	function edituserdetails() {
		global $mainframe;		
		
		$_name		  = JRequest::getVar( 'name', '', 'get', 'string' );
		
		$model        = &$this->getModel ( 'user' );
		$view         = $this->getView  ( 'user','html' );
		
		$_row = $model->_edit_pointsDetails ();
		$_rule_name = $model->_get_rule_name ($_row->rule);
		
		$view->assign('row', $_row );	
		$view->assign('name', $_name );
		$view->assign('rulename', $_rule_name );
		
		// Display
		$view->_edit_pointsDetails();				
	
	}
	
	function saveuserdetails () {
		global $mainframe;
		
		$model        = &$this->getModel ( 'user' );
		// save user details
		$model->_save_user_details ();	
	
	}
	
	function canceluserdetails() {
		global $mainframe;
		
		$redirecturl = JRequest::getVar( 'redirect', '', 'post', 'string' );
		
		$redirecturl = "index.php?option=com_alphauserpoints&task=" . $redirecturl ;		
		$mainframe->redirect( $redirecturl );	
	
	}
	

	function deleteuserdetails () {	
		global $mainframe;
		
		$model        = &$this->getModel ( 'user' );
		// delete 
		$model->_delete_user_details ();
	}	
	
	
	
	/**
	* Show Form Install Plugins
	*/
	function plugins() {
		global $mainframe;
		
		$view  = $this->getView ( 'plugins','html');
		
		$view->show();
	}
	
	/**
	* Upload Plugin
	*/
	function uploadfile() {
		global $mainframe;
	
		$view  = $this->getView ( 'plugins','html');		
		
		$error = "";
		$msg = "";
	
		if (@is_uploaded_file($_FILES["userfile"]["tmp_name"])) {
			require_once (JPATH_COMPONENT_ADMINISTRATOR  .DS . 'assets' . DS.'includes'.DS.'alphauserpoints.installer.php');
			$installer = new aupInstaller();
			
			$file = $installer->install( $_FILES["userfile"] );
						
			if ( $file ) {
				// extract data of xml file
				$this->loadPluginElements( $file );
			
			} else {
				$error = JText::_('AUP_FILEUPLOAD_ERROR');
				JError::raiseWarning(0, $error );
				$view->show();
			}
		} else {
			$error = JText::_('AUP_FILEUPLOAD_ERROR');
			JError::raiseWarning(0, $error );
			$view->show();
		}
	
	}
	
	/**
	 * Loading of related XML files
	 *
	*/
	function loadPluginElements( $xmlFile ) {
		global $mainframe;
		
		$error = "";
	
		// XML library
		require_once( JPATH_SITE . "/includes/domit/xml_domit_lite_include.php" );

		$xmlDoc =& new DOMIT_Lite_Document();
		$xmlDoc->resolveErrors( true );
		if ($xmlDoc->loadXML( JPATH_COMPONENT_ADMINISTRATOR . DS . 'assets' . DS . 'plugins' . DS . $xmlFile, false, true )) {
			$element = &$xmlDoc->documentElement;
			if ($element->getTagName() == 'alphauserpoints') {
				if ( $element->getAttribute('type')=='plugin' ) {
					$nameRule =& $element->getElementsByTagName('rule', 1);
					$nameRule =& $nameRule->item(0);
					$nameRule = trim($nameRule->getText());					
					$descriptionRule =& $element->getElementsByTagName('description', 1);
					$descriptionRule =& $descriptionRule->item(0);
					$descriptionRule = trim($descriptionRule->getText());
					$componentRule =& $element->getElementsByTagName('component', 1);
					$componentRule =& $componentRule->item(0);
					$componentRule = trim($componentRule->getText());					
					$pluginRule =& $element->getElementsByTagName('plugin_function', 1);
					$pluginRule =& $pluginRule->item(0);
					$pluginRule = trim($pluginRule->getText());					
					$fixedpointsRule =& $element->getElementsByTagName('fixed_points', 1);
					$fixedpointsRule =& $fixedpointsRule->item(0);
					$fixedpointsRule = trim(strtolower($fixedpointsRule->getText()));
					
					//if ( $fixedpointsRule == '' || !is_bool( $fixedpointsRule ) ) $fixedpointsRule = 1;
					//$fixedpointsRule = settype( $fixedpointsRule, "integer");					
					$fixedpointsRule = ( $fixedpointsRule=='true' ) ? 1 : 0;		
					
					// insert in table
					if ( $nameRule!='' && $descriptionRule!='' && $componentRule!='' && $pluginRule!='') {
					
						$db	=& JFactory::getDBO();
						// check if already exist...					
						$query = "SELECT COUNT(*) FROM #__alpha_userpoints_rules WHERE `plugin_function`='$pluginRule'";
						$db->setQuery( $query );
						$resultCount = $db->loadResult();
						if ( !$resultCount ) {
							$query = "INSERT INTO `#__alpha_userpoints_rules` VALUES ('', '$nameRule', '$descriptionRule', '$componentRule', '$pluginRule', '1', '$componentRule', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 0, 0, 0, 1, '$fixedpointsRule')";
							$db->setQuery( $query );
							$db->query();	
							$msg = JText::_('AUP_NEW_RULE_INSTALLED_SUCCESSFULLY');
							$mainframe->enqueueMessage( $msg );
							return $this->rules();				
						} else {
							$error = JText::_('AUP_THISRULEALREADYEXIST');
							JError::raiseNotice(0, $error );
							return $this->plugins();						
						}
					}  else {
						$error = JText::_('AUP_XML_FILE_INVALID');
						JError::raiseWarning(0, $error );
						return $this->plugins();
					}										
				} else {
					$error = JText::_('AUP_XML_FILE_INVALID');
					JError::raiseWarning(0, $error );
					return $this->plugins();
				}
			} else {
				$error = JText::_('AUP_XML_FILE_INVALID');
				JError::raiseWarning(0, $error );
				return $this->plugins();
			}
		} 
	}
	
	
	/**
	* Export 50 most active users in CSV
	*/
	function exportactiveusers() {
	
		$model        = &$this->getModel ( 'exports' );
		$_row = $model->_export_most_active_users ();		
		
		if ( $_row ) {		
			$totalRecords = 0;
			$fileName     = "mostactiveusers_" . uniqid(rand(), true) . ".csv";	
			$filepath     = JPATH_COMPONENT_ADMINISTRATOR . DS . 'assets' . DS . "csv" . DS . $fileName;
			
			$handler = fopen($filepath,"a");
			fwrite($handler,"NUM,USER ID,NAME,USERNAME,POINTS,ALPHAUSERPOINTS ID"."\n");

			$total = count( $_row );
			$j = 0;
			for ($i=0;$i< $total;$i++) {
				if ( $_row[$i]->referreid != 'GUEST' ) {
					$j++;
					fwrite( $handler, $j . "," . $_row[$i]->iduser . "," . $_row[$i]->name . "," . $_row[$i]->username . "," . $_row[$i]->points . "," . $_row[$i]->referreid . "\n" );
				}
			}
	
			header("Expires: Mon, 26 Nov 1962 00:00:00 GMT");
			header("Last-Modified: " . gmdate('D,d M Y H:i:s') . ' GMT');
			header("Cache-Control: no-cache, must-revalidate");
			header("Pragma: no-cache");
			header("Content-Type: text/x-comma-separated-values");
			header("Content-Disposition: attachment; filename=$fileName");
			
			readfile($filepath);
			
			exit;
		} else {
			$error = JText::_('AUP_NO_DATA');
			JError::raiseWarning(0, $error );
			return $this->cpanel();
		} 
	
	}

	/**
	* Export all e-mails addresses sent in CSV
	*/
	function exportemails() {
	
		jimport( 'joomla.mail.helper' );
	
		$model        = &$this->getModel ( 'exports' );		
		$_row = $model->_export_emails ();	
		
		if ( $_row ) {
			$totalRecords = 0;
			$fileName     = "export_emails_" . uniqid(rand(), true) . ".csv";	
			$filepath     = JPATH_COMPONENT_ADMINISTRATOR . DS . 'assets' . DS . "csv" . DS . $fileName;
			
			$handler= fopen($filepath,"a");
			fwrite($handler,"EMAIL"."\n");
			
			$total = count( $_row );
			for ($i=0;$i< $total;$i++) {
				$aEmails[0] = $this->extractEmailsFromString($_row[$i]->datareference);
				$email= $aEmails[0][0];
				if ( JMailHelper::isEmailAddress($email) ) {				
					fwrite($handler,$email."\n");
				}				
			}
	
			header("Expires: Mon, 26 Nov 1962 00:00:00 GMT");
			header("Last-Modified: " . gmdate('D,d M Y H:i:s') . ' GMT');
			header("Cache-Control: no-cache, must-revalidate");
			header("Pragma: no-cache");
			header("Content-Type: text/x-comma-separated-values");
			header("Content-Disposition: attachment; filename=$fileName");
			
			readfile($filepath);
			
			exit;
		} else {
			$error = JText::_('AUP_NO_DATA');
			JError::raiseWarning(0, $error );
			return $this->cpanel();
		} 
	
	}
	
	
	/**
	* Common publish/unpublish function
	*/
	function publish() {
	
		$option		= JRequest::getVar( 'option', 'com_alphauserpoints', 'post' );
		$table  	= JRequest::getVar( 'table', '', 'post' );	
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 'cpanel' );
		
		$model      = &$this->getModel ( 'helper' );
		$model->_aup_publish( $cid, 1, $option, $table, $redirect );
	
	}
	
	function unpublish() {
	
		$option		= JRequest::getVar( 'option', 'com_alphauserpoints', 'post' );
		$table  	= JRequest::getVar( 'table', '', 'post');
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 'cpanel' );
		
		$model      = &$this->getModel ( 'helper' );
		$model->_aup_publish( $cid, 0, $option, $table, $redirect );	

	}
	
	
	
	function autoapprove() {
	
		$option		= JRequest::getVar( 'option', 'com_alphauserpoints', 'post' );
		$table  	= JRequest::getVar( 'table', '', 'post' );	
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 'cpanel' );
		
		$model      = &$this->getModel ( 'helper' );
		$model->_aup_autoapprove( $cid, 1, $option, $table, $redirect );
	
	}
	
	function unautoapprove() {
	
		$option		= JRequest::getVar( 'option', 'com_alphauserpoints', 'post' );
		$table  	= JRequest::getVar( 'table', '', 'post');
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 'cpanel' );
		
		$model      = &$this->getModel ( 'helper' );
		$model->_aup_autoapprove( $cid, 0, $option, $table, $redirect );	

	}
	
	function approve() {
	
		$option		= JRequest::getVar( 'option', 'com_alphauserpoints', 'post' );
		$table  	= JRequest::getVar( 'table', '', 'post' );	
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 'cpanel' );
		
		$model      = &$this->getModel ( 'helper' );
		$model->_aup_approve( $cid, 1, $option, $table, $redirect );
	
	}
	
	function unapprove() {
	
		$option		= JRequest::getVar( 'option', 'com_alphauserpoints', 'post' );
		$table  	= JRequest::getVar( 'table', '', 'post');
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 'cpanel' );
		
		$model      = &$this->getModel ( 'helper' );
		$model->_aup_approve( $cid, 0, $option, $table, $redirect );	

	}
	
	/**
	* Common change access function
	*/	
	function accesspublic() {
		global $mainframe;
		
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		$model =& $this->getModel( 'rules' );
		$model->setAccess($cid, 0);
		$mainframe->redirect( 'index.php?option=com_alphauserpoints&task=rules', $msg );
	}

	function accessregistered() {
		global $mainframe;
		
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		$model =& $this->getModel( 'rules' );
		$model->setAccess($cid, 1);
		$mainframe->redirect( 'index.php?option=com_alphauserpoints&task=rules', $msg );
	}

	function accessspecial() {
		global $mainframe;
		
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		$model =& $this->getModel( 'rules' );
		$model->setAccess($cid, 2);
		$mainframe->redirect( 'index.php?option=com_alphauserpoints&task=rules', $msg );
	}
	
	function extractEmailsFromString($sChaine) {	 
		if(false !== preg_match_all('`\w(?:[-_.]?\w)*@\w(?:[-_.]?\w)*\.(?:[a-z]{2,4})`', $sChaine, $aEmails)) {
			if(is_array($aEmails[0]) && sizeof($aEmails[0])>0) {
				return array_unique($aEmails[0]);
			}
		}		 
		return null;
	}
	
	function applybonus() {
		global $mainframe;
		
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		
		if (count($cid) < 1) {
			JViewContent::displayError( JText::_('Select an item to') . ' ' . JText::_($action) );
			return false;
		}
		
		$model      = &$this->getModel ( 'helper' );
		$model->_bonuspoints( $cid );	
	
	}
	
	function rejectrequest() {
		global $mainframe;	
		
		$model =& $this->getModel( 'requests' );
		$model->_rejectlevel();
		
		$error = JText::_('AUP_REQUESTREJECTED');
		JError::raiseNotice(0, $error );
		$mainframe->redirect( 'index.php?option=com_alphauserpoints&task=cpanel' );
	
	}
	
	function changeuserlevel() {
	
		global $mainframe;	
		
		$model =& $this->getModel( 'requests' );
		$model->_acceptlevel();
				
		$mainframe->redirect( 'index.php?option=com_alphauserpoints&task=cpanel' );

	}

}
?>