DROP TABLE IF EXISTS #__alpha_userpoints;
CREATE TABLE IF NOT EXISTS #__alpha_userpoints (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `referreid` varchar(20) NOT NULL default '',
  `points` int(11) NOT NULL default '0',
  `max_points` int(11) NOT NULL default '0',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `referraluser` varchar(20) NOT NULL default '',
  `referrees` int(11) NOT NULL default '0',
  `blocked` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS #__alpha_userpoints_details;
CREATE TABLE IF NOT EXISTS #__alpha_userpoints_details (
  `id` int(11) NOT NULL auto_increment,
  `referreid` varchar(20) NOT NULL default '',
  `points` int(11) NOT NULL default '0',
  `insert_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `expire_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` tinyint(1) NOT NULL default '0',
  `rule` int(11) NOT NULL default '0',
  `approved` tinyint(1) NOT NULL default '1',
  `keyreference` varchar(100) NOT NULL default '',
  `datareference` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS #__alpha_userpoints_rules;
CREATE TABLE IF NOT EXISTS #__alpha_userpoints_rules (
  `id` int(11) NOT NULL auto_increment,
  `rule_name` varchar(30) NOT NULL default '',
  `rule_description` varchar(255) NOT NULL default '',
  `rule_plugin` varchar(30) NOT NULL default '', 
  `plugin_function` varchar(50) NOT NULL default '', 
  `access` tinyint(1) NOT NULL default '1',
  `component` varchar(50) NOT NULL default '',
  `calltask` varchar(50) NOT NULL default '',
  `taskid` varchar(50) NOT NULL default '',
  `points` int(11) NOT NULL default '0',
  `percentage` tinyint(1) NOT NULL default '0',
  `rule_expire` datetime NOT NULL default '0000-00-00 00:00:00',
  `sections` text NOT NULL default '',
  `categories` text NOT NULL default '',
  `content_items` text NOT NULL default '',
  `exclude_items` text NOT NULL default '',
  `published` tinyint(1) NOT NULL default '0',
  `system` tinyint(1) NOT NULL default '0',
  `duplicate` tinyint(1) NOT NULL default '0',
  `blockcopy` tinyint(1) NOT NULL default '0',
  `autoapproved` tinyint(1) NOT NULL default '1',
  `fixedpoints` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS #__alpha_userpoints_requests;
CREATE TABLE IF NOT EXISTS #__alpha_userpoints_requests (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `referreid` varchar(20) NOT NULL default '',
  `name` varchar(50) NOT NULL default '',
  `username` varchar(50) NOT NULL default '',  
  `levelrequest` int(11) NOT NULL default '0',
  `checked` tinyint(1) NOT NULL default '0',
  `checkedadmin` tinyint(1) NOT NULL default '0',
  `response` tinyint(1) NOT NULL default '0',
  `requestdate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

INSERT INTO #__alpha_userpoints (`id`, `userid`, `referreid`, `points`, `max_points`, `last_update`, `referraluser`, `referrees`, `blocked`) VALUES ('', '0', 'GUEST', '0', '0', '0000-00-00 00:00:00', '', '0', '0');

INSERT INTO #__alpha_userpoints_rules (`id`, `rule_name`, `rule_description`, `rule_plugin`, `plugin_function`, `access`, `component`, `calltask`, `taskid`, `points`, `percentage`, `rule_expire`, `sections`, `categories`, `content_items`, `exclude_items`, `published`, `system`, `duplicate`, `blockcopy`, `autoapproved`, `fixedpoints`) VALUES
('', 'AUP_NEWUSER', 'AUP_NEWUSERDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_newregistered', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 1, 1, 0, 1, 1, 1),
('', 'AUP_INVITE', 'AUP_INVITE_A_USER', 'AUP_SYSTEM', 'sysplgaup_invite', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_INVITESUCCES', 'AUP_INVITE_A_USERSUCCESS', 'AUP_SYSTEM', 'sysplgaup_invitewithsuccess', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_SUBMITANARTICLE', 'AUP_SUBMITANARTICLEDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_submitarticle', '2', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 0, 1),
('', 'AUP_SUBMITAWEBLINK', 'AUP_SUBMITAWEBLINKDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_submitweblink', '2', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 0, 1),
('', 'AUP_INVITETOREADARTICLE', 'AUP_INVITETOREADARTICLEDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_recommend', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_READTOAUTHOR', 'AUP_READTOAUTHORDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_reader2author', '0', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_ANSWERINGAPOLL', 'AUP_ANSWERINGAPOLLDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_answeringpoll', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_USER2USERPOINTS', 'AUP_USER2USERPOINTSDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_user2userpoints', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 0),
('', 'AUP_REFERRALPOINTS', 'AUP_REFERRALPOINTSDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_referralpoints', '1', '', '', '', 0, 1, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_BONUSPOINTS', 'AUP_BONUSPOINTSDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_bonuspoints', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_BECOME_AUTHOR', 'AUP_BECOME_AUTHOR_DESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_becomeauthor', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_BECOME_EDITOR', 'AUP_BECOME_EDITOR_DESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_becomeeditor', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_BECOME_PUBLISHER', 'AUP_BECOME_PUBLISHER_DESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_becomepublisher', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 1),
('', 'AUP_EXCLUDESPECIFICUSERS', 'AUP_EXCLUDESPECIFICUSERSDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_excludeusers', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 0),
('', 'AUP_EMAILNOTIFICATION', 'AUP_EMAILNOTIFICATIONDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_emailnotification', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 0),
('', 'AUP_WINNERNOTIFICATION', 'AUP_WINNERNOTIFICATIONDESCRIPTION', 'AUP_SYSTEM', 'sysplgaup_winnernotification', '1', '', '', '', 0, 0, '0000-00-00 00:00:00', '', '', '', '', 0, 1, 0, 1, 1, 0);