<?php
/*
 * @component AlphaUserPoints
 * @copyright Copyright (C) 2008 Bernard Gilly
 * @license : GNU/GPL
 * @Website : http://www.alphaplug.com
 */

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * AlphaUserPoints System Plugin
 *
 * @package		Joomla
 * @subpackage	AlphaUserPoints
 * @since 		1.5
 */
class plgSystemAlphaUserPoints extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgSystemAlphaUserPoints(& $subject, $config) {
		parent::__construct($subject, $config);
	}

	function onAfterRender()
	{
		global $mainframe;
		
		// No need in admin panel
		if( $mainframe->isAdmin() ) return;
		
		$option = JRequest::getCmd('option', '');		
		$task   = JRequest::getCmd('task', '');
		
		$view   = JRequest::getVar('view', ''); 
		$link   = JRequest::getVar('link', '');
		$id 	= JRequest::getVar('id', 0);		
		
		if ( file_exists(JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php') ) {
			require_once (JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php');
		} else return;
		
		//$newkeyreference = uniqid(rand(), true);
		
		@session_start('alphauserpoints');
		
		switch ( $task ) {
			case 'register' :
				// New user (Joomla core system)
				if ( $option=='com_user' && !$_SESSION['referrerid'] ) {					
					$_SESSION['referrerid'] = JRequest::getVar('referrer', '', 'GET', 'string');
				}				
				break;
			case 'registers' :
				// New user (Community Builder)
				if ( $option=='com_comprofiler' && !$_SESSION['referrerid'] ) {					
					$_SESSION['referrerid'] = JRequest::getVar('referrer', '', 'GET', 'string');
				}				
				break;
			
			default:

		}
	}
	
	function onAfterInitialise()
	{
		global $mainframe;
		
		// No need in admin panel
		if( $mainframe->isAdmin() ) return;
				
		$option = JRequest::getCmd('option', '');
		$task   = JRequest::getCmd('task', '');
		
		$view   = JRequest::getVar('view', '');

		$link   = base64_decode ( JRequest::getVar('link', '', 'post', 'base64') );
		$id 	= JRequest::getVar('id', 0);		
		
		$referreruser = JRequest::getVar('referreruser', '', 'GET', 'string'); // used for invite a friend to read
		$keyreference = JRequest::getVar('keyreference', '', 'GET', 'string'); // used for invite a friend to read		
		$datareference = JRequest::getVar('datareference', '', 'GET', 'string'); // used for invite a friend to read
			
		if ( file_exists(JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php') ) {
			require_once (JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php');
		} else return;
		
		JPlugin::loadLanguage( 'com_alphauserpoints' );
		
		$newkeyreference = uniqid(rand(), true);
		
		@session_start('alphauserpoints');
		
		$referreid = @$_SESSION['referrerid'];
		
		switch ( $task ) {
			case 'vote':
				// Answering a poll
				if ( $option=='com_poll' ) {					
					if ( $id ) {
						$db	   =& JFactory::getDBO();
						$query = "SELECT `title` FROM #__polls WHERE id='$id' AND `published`='1'";
						$db->setQuery( $query );
						$titlepoll = $db->loadResult();
						if ( $titlepoll ) {
							AlphaUserPointsHelper::userpoints( 'sysplgaup_answeringpoll', '', 0, $id, $titlepoll );
						}
					}				
				}
				break;
			case 'save':
				// Submit article
				if ( $option=='com_content' ) {
					$title = JRequest::getVar('title', '', 'post', 'string');	
					if ( !$id && $title!='' ) {											
						AlphaUserPointsHelper::userpoints( 'sysplgaup_submitarticle', '', 0, '', $title );
					}
				}
				// Submit weblink
				if ( $option=='com_weblinks' ) {
					if ( AlphaUserPointsHelper::checkRuleEnabled('sysplgaup_submitweblink') ) {
						$jform = JRequest::getVar('jform', array(), 'post', 'array');
						$url = $jform['url'];
						AlphaUserPointsHelper::userpoints( 'sysplgaup_submitweblink', '', 0, '', $url );
					}					
				}
				break;
			case 'send':
				// Recommend an article : Invite a friend to read -> on send email
				if ( $option=='com_mailto' && $referreid!='' && $link!='' ) {
					if ( AlphaUserPointsHelper::checkRuleEnabled('sysplgaup_recommend') ) {
						$linkcontinued = "&referreruser=$referreid&keyreference=$newkeyreference";		
						$mailto = "&datareference=";
						$mailto .= JRequest::getVar('mailto', '', 'post', 'string');
						$link = $link . $linkcontinued . $mailto;
						JRequest::setVar( 'link', base64_encode($link) );
					}
				}
				break;
			default:
				// Recommend an article : friend (registered or not) read with success
				if ( $view=='article' && $referreruser!='' && $keyreference!='' && $datareference!='' ) {
					AlphaUserPointsHelper::userpoints( 'sysplgaup_recommend', $referreruser, 0, $keyreference, $datareference );
				}				

		}
	}

}
?>