<?php
/*
 * @component AlphaUserPoints
 * @copyright Copyright (C) 2008 Bernard Gilly
 * @license : GNU/GPL
 * @Website : http://www.alphaplug.com
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgUserSysplgaup_newregistered extends JPlugin {

	function plgUsersysplgaup_newregistered(& $subject, $config)
	{
		parent::__construct($subject, $config);
		
	}
	
	function onAfterStoreUser($user, $isnew, $succes, $msg) {
		global $mainframe;
		
		if ( $isnew ) {
		
			JPlugin::loadLanguage( 'com_alphauserpoints' );
			
			// Get plugin info
			$plugin =& JPluginHelper::getPlugin('user', 'sysplgaup_newregistered');
			$pluginParams = new JParameter( $plugin->params );
			
			// AUPRR = AlphaUserPoints Register by Referrer, AUPRS AlphaUserPoints Register by Self
			$prefixSelfRegister = $pluginParams->get( 'prefix_selfregister', 'AUPRS-' ) ;
			$prefixReferralRegister = $pluginParams->get( 'prefix_referralregister', 'AUPRR-' ) ;
		
			$referrerid = trim($_SESSION['referrerid']);
			unset($_SESSION['referrerid']);
		
			$db	   =& JFactory::getDBO();
			$query = "SELECT * FROM #__alpha_userpoints_rules WHERE `plugin_function`='sysplgaup_newregistered' AND `published`='1'";
			$db->setQuery( $query );
			$result  = $db->loadObjectList();
			
			$prefixNewReferreid = ( $referrerid!='' ) ? $prefixReferralRegister : $prefixSelfRegister; 
	
			// if rule enabled
			if ( $result ) {			
				
				$newreferreid = strtoupper(uniqid ( $prefixNewReferreid, false ));	
					
				JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_alphauserpoints'.DS.'tables');
				
				$row =& JTable::getInstance('userspoints');
				// insert this new user into alphauserpoints table
			    $row->id			= NULL;
				$row->userid		= $user['id'];
			    $row->referreid		= $newreferreid;
			    $row->points		= $result[0]->points;
			    $row->max_points	= 0;
				$row->last_update	= $user['registerDate'];
			    $row->referraluser	= $referrerid;
				
				if (!$row->store()) {
					JError::raiseError(500, $row->getError());
				}				
				
				// save new points into alphauserpoints table details
				$row2 =& JTable::getInstance('userspointsdetails');
			    $row2->id				= NULL;
			    $row2->referreid		= $newreferreid;
			    $row2->points			= $result[0]->points;
				$row2->insert_date		= $user['registerDate'];
			    $row2->expire_date 		= $result[0]->rule_expire;
			    $row2->status			= $result[0]->autoapproved;
				$row2->rule				= $result[0]->id;
			    $row2->approved			= $result[0]->autoapproved;
				$row2->datareference	= JText::_( 'AUP_WELCOME' );				
			  			
				if (!$row2->store()) {
					JError::raiseError(500, $row2->getError());
				}				
				
				if ( $referrerid ) {
					$data = htmlspecialchars( $user['name'], ENT_QUOTES, 'UTF-8') . " (" . $user['username'] . ") ";
					$data = sprintf ( JText::_('AUP_X_HASJOINEDTHEWEBSITE'), $data );
					$this->sysplgaup_invitewithsuccess( $referrerid, $data );
				}
				
				return true;
				
			} else return false;						
		}
	}
	
	function onAfterDeleteUser($user, $succes, $msg) {
		global $mainframe;

		$db	   =& JFactory::getDBO();
		
		$query = "SELECT `referreid` FROM #__alpha_userpoints WHERE `userid`='".$user['id']."'";
		$db->setQuery( $query );
		$referreid  = $db->loadResult();

		$query = "DELETE FROM #__alpha_userpoints WHERE `userid`='".$user['id']."'";
		$db->setQuery( $query );
		$db->query();
		
		$query = "DELETE FROM #__alpha_userpoints_details WHERE `referreid`='".$referreid."'";
		$db->setQuery( $query );
		$db->query();
		
	}

	
	function sysplgaup_invitewithsuccess( $referrerid, $data ) {

		require_once (JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php');
		AlphaUserPointsHelper::userpoints( 'sysplgaup_invitewithsuccess', $referrerid, 0, '', $data );

	}
	
	function onLoginUser($user, $options)
	{
		jimport('joomla.user.helper');

		$instance = new JUser();
		if($id = intval(JUserHelper::getUserId($user['username'])))  {
			$instance->load($id);
		}
		
		if ($instance->get('block') == 0) {
			require_once (JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php');			
			AlphaUserPointsHelper::getReferreid( intval($instance->get('id')) );
	
			return true;
		}		
		
	}
	
	function onLogoutUser($user, $options = array()) {
		//Make sure we're a valid user first
		if($user['id'] == 0) return true;

		unset($_SESSION['referrerid']);
		return true;
	}
}
?>