<?php
/*
 * @component AlphaUserPoints
 * @copyright Copyright (C) 2008 Bernard Gilly
 * @license : GNU/GPL
 * @Website : http://www.alphaplug.com
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

class alphauserpointsModelStatistics extends Jmodel {

	function __construct(){
		parent::__construct();
	}
	
	function _needsync () {
	
		$db			    =& JFactory::getDBO();
		
		$query = "SELECT count(*) FROM #__users";
		$db->setQuery( $query );
		$totalUSers = $db->loadResult();
		
		$query = "SELECT count(*) FROM #__alpha_userpoints";
		$db->setQuery( $query );
		$totalReferral = ( $db->loadResult() - 1 ); // remove GUEST user
		
		if ( $totalUSers != $totalReferral ) {		
			return true;		
		} else return false;		
	
	}
	
	function _load_users() {	
		global $mainframe, $option;
		
		$db			    =& JFactory::getDBO();
		
		$filter_order		= $mainframe->getUserStateFromRequest( "$option.filter_order",		'filter_order',		'u.name',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( "$option.filter_order_Dir",	'filter_order_Dir',	'',			'word' );
		$search				= $mainframe->getUserStateFromRequest( "$option.search",			'search',			'',		  'string' );
		$search				= JString::strtolower( $search );
		
		$orderby = " ORDER BY " . $filter_order . " " . $filter_order_Dir;
		
		$total 			= 0;
		
		//$limit			= $mainframe->getUserStateFromRequest('com_alphauserpoints.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		//$limitstart		= $mainframe->getUserStateFromRequest('com_alphauserpoints.limitstart', 'limitstart', 0, 'int');
		
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_alphauserpoints.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		// In case limit has been changed, adjust limitstart accordingly
		$limitstart = ( $limit != 0 ? (floor( $limitstart / $limit ) * $limit) : 0);
		
		
		$where = array();
		
		if ($search) {
			$where[] = 'LOWER(u.name) LIKE '. $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'LOWER(u.username) LIKE '. $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'LOWER(a.referreid) LIKE '. $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		$where 		= ( count( $where ) ? " AND (" . implode( ' OR ', $where ) .")" : "" );

		$query = "SELECT a.*, u.name, u.username FROM #__alpha_userpoints AS a, #__users AS u WHERE u.id = a.userid " . $where . $orderby;
		$total = @$this->_getListCount($query);
		$result = $this->_getList($query, $limitstart, $limit);
		/*
		for ($i=0, $n=count( $result ); $i < $n; $i++) {
			$row 	= $result[$i];			
			$query = "SELECT count(*) FROM #__alpha_userpoints WHERE `referraluser`='" . $result[$i]->referreid . "'";
			$db->setQuery( $query );
			$referrees = $db->loadResult();
			$result[$i]->referrees = intval($referrees);		
		}
		*/
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
		// search filter
		$lists['search']    = $search;
		
		return array($result, $total, $limit, $limitstart, $lists);
	
	}
	
	function _edit_user() {
	
		$db     =& JFactory::getDBO();

		$cid 	= JRequest::getVar('cid', array(0));
		$option = JRequest::getVar('option');
		
		if (!is_array( $cid )) {
			$cid = array(0);
		}

		$lists = array();

		$row =& JTable::getInstance('userspoints');
		$row->load( $cid[0] );
		
		// get name and username
		$query = "SELECT name, username FROM #__users WHERE `id`='$row->userid'";
		$db->setQuery( $query );
		$result  = $db->loadObjectList();
		$row->name = $result[0]->name;
		$row->username = $result[0]->username;
		
		return $row;
	
	}
	
	function _save_user() {
		global $mainframe;

		// initialize variables
		$db =& JFactory::getDBO();
		$post	= JRequest::get( 'post' );
		$row =& JTable::getInstance('userspoints');
		
		// last update
		$jnow		=& JFactory::getDate();
		$now		= $jnow->toMySQL();
		
		$row->last_update = $now;

		if (!$row->bind( $post )) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$msg = JText::_( 'AUP_GENERALSTATSSAVED' );
		$mainframe->redirect( 'index.php?option=com_alphauserpoints&task=statistics', $msg );
	}
	
	function _load_top10 () {
	
		$db =& JFactory::getDBO();
	
		$query = "SELECT a.*, u.name, u.username FROM #__alpha_userpoints AS a, #__users AS u WHERE u.id = a.userid ORDER BY a.points DESC, u.name ASC";
		$result = $this->_getList($query, 0, 10);
		
		return $result;
	
	}
	
	function _load_unapproved() {
	
		$db =& JFactory::getDBO();
		
		$query = "SELECT a.insert_date, a.referreid, a.points AS pendingapprovalpoints, r.rule_name, u.name , u.username"
			   . " FROM #__alpha_userpoints_details AS a, #__alpha_userpoints_rules AS r, #__alpha_userpoints AS aup, #__users AS u"
			   . " WHERE r.id=a.rule AND aup.referreid=a.referreid AND aup.userid=u.id AND a.approved='0' AND a.status='0'"
			   . " ORDER BY a.insert_date DESC";
		$total  = @$this->_getListCount($query);
		$result = $this->_getList($query, 0, 10);
		
		return array($result, $total);
	}	

}
?>