<?php
/*
 * @component AlphaUserPoints
 * @copyright Copyright (C) 2008 Bernard Gilly
 * @license : GNU/GPL
 * @Website : http://www.alphaplug.com
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

class alphauserpointsModelUser extends Jmodel {

	function __construct(){
		parent::__construct();
	}
	

	function _load_details_user() {
		global $mainframe, $option;
		
		$db			    =& JFactory::getDBO();
		
		$referreuserid		= JRequest::getVar( 'cid', '' );
		
		$filter_order		= $mainframe->getUserStateFromRequest( "$option.filter_order",		'filter_order',		'a.insert_date',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( "$option.filter_order_Dir",	'filter_order_Dir',	'DESC',			'word' );
		$search				= $mainframe->getUserStateFromRequest( "$option.search",			'search',			'',		  'string' );
		$search				= JString::strtolower( $search );
		
		$orderby = " ORDER BY " . $filter_order . " " . $filter_order_Dir;
		
		//$total 			= 0;
		
		//$limit			= $mainframe->getUserStateFromRequest('com_alphauserpoints.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		//$limitstart		= $mainframe->getUserStateFromRequest('com_alphauserpoints.limitstart', 'limitstart', 0, 'int');
		
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_alphauserpoints.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		// In case limit has been changed, adjust limitstart accordingly
		$limitstart = ( $limit != 0 ? (floor( $limitstart / $limit ) * $limit) : 0);
		
		$where = array();
		
		$where[] = " a.referreid='$referreuserid' ";
		
		if ($search) {
			$where[] = 'LOWER(a.points) LIKE '. $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'LOWER(a.insert_date) LIKE '. $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'LOWER(a.datareference) LIKE '. $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'LOWER(r.rule_name) LIKE '. $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		$where 		= ( count( $where ) ? " AND (" . implode( ' OR ', $where ) .")" : "" );

		$query  = "SELECT a.*, r.rule_name FROM #__alpha_userpoints_details AS a, #__alpha_userpoints_rules AS r WHERE a.rule=r.id " . $where . $orderby;
		$total  = @$this->_getListCount($query);
		$result = $this->_getList($query, $limitstart, $limit);		
		
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
		// search filter
		$lists['search']    = $search;
		
		return array($result, $total, $limit, $limitstart, $lists);
		
	}	
	
	function _edit_pointsDetails() {
	
		$db     =& JFactory::getDBO();

		$cid 	= JRequest::getVar('cid', array(0));
		$option = JRequest::getVar('option');
		
		if (!is_array( $cid )) {
			$cid = array(0);
		}

		$lists = array();

		$row =& JTable::getInstance('userspointsdetails');
		$row->load( $cid[0] );
		
		return $row;
		
	}
	
	function _get_rule_name ( $id ) {
	
		$db     =& JFactory::getDBO();
		
		$query  = "SELECT rule_name FROM #__alpha_userpoints_rules WHERE id='" . $id . "'";
		$db->setQuery( $query );
		$rulename = $db->loadResult();

		return $rulename;	
	
	}
	
	function _save_user_details() {
		global $mainframe;

		// initialize variables
		$db =& JFactory::getDBO();
		$post	= JRequest::get( 'post' );
		$row =& JTable::getInstance('userspointsdetails');

		if (!$row->bind( $post )) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$msg = JText::_( 'AUP_DETAILSSAVED' );
		$redirect = 'index.php?option=com_alphauserpoints&task=' . $post['redirect'];
		$mainframe->redirect( $redirect, $msg );
	}
	
	function _delete_user_details () {
		global $mainframe;

		// initialize variables
		$db			=& JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(), 'post', 'array');
		
		$post	= JRequest::get( 'post' );
		
		$msgType	= '';
		
		JArrayHelper::toInteger($cid);
		
		if (count($cid)) {		
			
			$msg = JText::_('AUP_SUCCESSFULLYDELETED');
		
			$query = "DELETE FROM #__alpha_userpoints_details"
					. "\n WHERE (`id` = " . implode(' OR `id` = ', $cid) . ")"
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				JError::raiseError( 500, $db->getErrorMsg() );
				return false;
				//$msg = $db->getErrorMsg();
				//$msgType = 'error';
			}

		}
		
		$mainframe->enqueueMessage( $msg );
		//$redirect = 'index.php?option=com_alphauserpoints&task=' . $post['redirect'];
		$redirect ='index.php?option=com_alphauserpoints&task=recalculate';
		$mainframe->redirect( $redirect );
	
	}
	
}
?>