<?php
/*
 * @component AlphaUserPoints
 * @copyright Copyright (C) 2008 Bernard Gilly
 * @license : GNU/GPL
 * @Website : http://www.alphaplug.com
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

class alphauserpointsModelUsers extends Jmodel {

	function __construct(){
		parent::__construct();
	}
	
	function _setmaxpoints() {
	
		$db			= & JFactory::getDBO();
		$maxpoints	= JRequest::getVar( 'setpointsperuser', 0, 'post', 'int' );
			// main query
		$query = "UPDATE #__alpha_userpoints SET `max_points`='$maxpoints'";
		$db->setQuery($query);
		$db->query();
		
		return $maxpoints;
		
	}
	
	function _setusersync() {
	
		$db			= & JFactory::getDBO();
		
		$jnow		=& JFactory::getDate();
		$now		= $jnow->toMySQL();		
		
		$prefixNewReferreid = "AUPRS-";
		
		$i = 0;
		
		// main query
		$query = "SELECT id FROM #__users";
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		// rule new user
		$query = "SELECT * FROM #__alpha_userpoints_rules WHERE `plugin_function`='sysplgaup_newregistered' AND `published`='1'";
		$db->setQuery( $query );
		$ruleNewUser = $db->loadObjectList();
		
		if ( $users ) {		
			foreach ( $users as $user ) {			
				// check if user exist
				$query = "SELECT referreid FROM #__alpha_userpoints WHERE userid='$user->id'";
				$db->setQuery($query);
				$checkuser = $db->loadResult();
				// if not exist -> create
				if ( !$checkuser ) {
				
					$i ++;
				
					$newreferreid = strtoupper(uniqid ( $prefixNewReferreid, false ));
					
					$row =& JTable::getInstance('userspoints');
					// insert this new user into alphauserpoints table
					$row->id			= NULL;
					$row->userid		= $user->id;
					$row->referreid		= $newreferreid;
					$row->points		= $ruleNewUser[0]->points;
					$row->max_points	= 0;
					$row->last_update	= $now;
					$row->referraluser	= '';
					
					if (!$row->store()) {
						JError::raiseError(500, $row->getError());
					}				
					
					// save new points into alphauserpoints table details
					$row2 =& JTable::getInstance('userspointsdetails');
					$row2->id				= NULL;
					$row2->referreid		= $newreferreid;
					$row2->points			= $ruleNewUser[0]->points;
					$row2->insert_date		= $now;
					$row2->expire_date 		= $ruleNewUser[0]->rule_expire;
					$row2->status			= $ruleNewUser[0]->autoapproved;
					$row2->rule				= $ruleNewUser[0]->id;
					$row2->approved			= $ruleNewUser[0]->autoapproved;
					$row2->datareference	= JText::_( 'AUP_WELCOME' );
							
					if (!$row2->store()) {
						JError::raiseError(500, $row2->getError());
					}				
				}				
			}	
		}		
		
		return $i;
		
	}
	
	function _resetpoints() {
		
		$db	= & JFactory::getDBO();
				
		$jnow		=& JFactory::getDate();		
		$now		= $jnow->toMySQL();
			
		// main query
		$query = "UPDATE #__alpha_userpoints SET `points`='0', `last_update`='$now'";
		$db->setQuery( $query );
		$db->query();
		
		// main query
		$query = "DELETE FROM #__alpha_userpoints_details";
		$db->setQuery( $query );
		$db->query();
		
		return true;
		
	}
	
	function _recalculate_points () {
	
		$db	= & JFactory::getDBO();
		
		$jnow		=& JFactory::getDate();		
		$now		= $jnow->toMySQL();		
		
		// delete old points after expire date
		$query = "DELETE FROM #__alpha_userpoints_details WHERE `expire_date`!='0000-00-00 00:00:00' AND `expire_date`<='$now'";
		$db->setQuery( $query );
		$db->query();
		
		// main query
		$query = "SELECT referreid FROM #__alpha_userpoints";
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		if ( $users ) {
			foreach ( $users as $user ) {			

				// real sum for each user
				$query = "SELECT SUM(points) FROM #__alpha_userpoints_details WHERE `referreid`='" . $user->referreid . "' AND `approved`='1' AND (`expire_date`>'$now' OR `expire_date`='0000-00-00 00:00:00')";
				$db->setQuery($query);
				$newtotal = $db->loadResult();	

				$query = "UPDATE #__alpha_userpoints SET `points`='" . intval($newtotal) . "', `last_update`='$now' WHERE `referreid`='" . $user->referreid . "'";
				$db->setQuery( $query );
				$db->query();		
				
			}
			
		}
			
		return true;
	
	}
	
	function _purge_expires () {
	
		$db	= & JFactory::getDBO();
		
		$jnow		=& JFactory::getDate();		
		$now		= $jnow->toMySQL();		
	
		// main query
		$query = "DELETE FROM #__alpha_userpoints_details WHERE `expire_date`!='0000-00-00 00:00:00' AND `expire_date`<='$now'";
		$db->setQuery( $query );
		$db->query();
		
		return true;
		
	}
	
}