<?php
/*
 * @component AlphaUserPoints
 * @copyright Copyright (C) 2008 Bernard Gilly
 * @license : GNU/GPL
 * @Website : http://www.alphaplug.com
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

/**
 * @package AlphaUserPoints
 */
class alphauserpointsController extends JController
{
	/**
	 * Custom Constructor
	 */
 	function __construct()	{
		parent::__construct( );
	}
	
	function user2userpoints() {
		global $mainframe;		
		
		$user = & JFactory::getUser();
		
		$model      = &$this->getModel ( 'alphauserpoints' );	
		$view       = $this->getView  ( 'user2userpoints','html' );			
		
		// active user		
		$referrerid = $model->_checkUser();

		// rule enabled ?
		require_once (JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php');
		
		$plugin_rule = AlphaUserPointsHelper::checkRuleEnabled( 'sysplgaup_user2userpoints' );
		
		if ( !AlphaUserPointsHelper::checkRuleEnabled( 'sysplgaup_user2userpoints' ) ) {
			$msg = JText::_('AUP_THISRULEDISABLED' );
			$mainframe->redirect('index.php', $msg, 'error');
		}
		
		// check referre ID
		$_user_info = AlphaUserPointsHelper::getUserInfo ( $referrerid );
		$currenttotalpoints = $_user_info->points;
		
		// Get the parameters of the active menu item
		$params = $model->_getParamsAUP();
				
		$view->assign('params', $params );
		$view->assign('referreid', $referrerid );
		$view->assign('userID', $user->id );
		$view->assign('currenttotalpoints', $currenttotalpoints );
		$view->assign('menuid', $menuid );
	
		// Display
		$view->_display();
	}
	
	
	function sendpoints () {
		global $mainframe;		
		
		$model        = &$this->getModel ( 'alphauserpoints' );
		$view         = $this->getView  ( 'user2userpoints','html' );		
		
		$model->_sendXpoints2friend();
		
		// Get the parameters of the active menu item
		$params = $model->_getParamsAUP();
				
		$view->assign('params', $params );
		$view->assign('username', $username );
		$view->assign('xpoints', $xpoints );
		$view->assign('newcurrenttotalpoints', $newcurrenttotalpoints );
		
	}
	
	function account () {
		global $mainframe;
		
		require_once (JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php');		
	
		$model      = &$this->getModel ( 'alphauserpoints' );
		$view       = $this->getView  ( 'account','html' );
		
		// check referre ID
		$referrerid = $model->_checkUser();
		
		$_listing_last_points   = $model->_get_last_points ( $referrerid );
		$rowsreferrees			= $model->_get_referrees ( $referrerid );
	
		$_user_info = AlphaUserPointsHelper::getUserInfo ( $referrerid );
		
		$currenttotalpoints    	= $_user_info->points;
		$lastupdate 			= $_user_info->last_update;
		$referraluser 			= $_user_info->referraluser;		
		
		$referralname = "";
		if ( $referraluser ) {
			$referralinfo = AlphaUserPointsHelper::getUserInfo ( $referraluser );
			$referralname = $referralinfo->username;
		} 
		
		// Get the parameters of the active menu item
		$params = $model->_getParamsAUP();		
		
		// check if rules for change user level is enabled
		$messageChangeLevel = "";
		$currentrequests = "";
		$user = & JFactory::getUser();
		if ( ($user->usertype=='Registered' || $user->usertype=='Author' || $user->usertype=='Editor') && !AlphaUserPointsHelper::checkExcludeUsers($referrerid) ) {
		
			$model2 = &$this->getModel ( 'currentrequests' );
			switch ( strtolower($user->usertype) ) {
			
				case 'registered':
					$changelevel1 = AlphaUserPointsHelper::checkRuleEnabled( 'sysplgaup_becomeauthor' );
					if ( $changelevel1 ) {					
						if ( $currenttotalpoints>=$changelevel1[0]->points ) {
							// Ready for change level: show message and current requests
							$messageChangeLevel = sprintf(JText::_( 'AUP_YOUHAVESUFFICIENTPOINTSBECOME'), JText::_( 'AUP_AUTHOR' ));							
						}
					}
					break;
					
				case 'author':
					$changelevel2 = AlphaUserPointsHelper::checkRuleEnabled( 'sysplgaup_becomeeditor' );
					if ( $changelevel1 ) {
						if ( $currenttotalpoints>=$changelevel2[0]->points ) {
							// Ready for change level
							$messageChangeLevel = sprintf(JText::_( 'AUP_YOUHAVESUFFICIENTPOINTSBECOME'), JText::_( 'AUP_EDITOR' ));
						}
					}
					break;
	
				case 'editor':
					$changelevel3 = AlphaUserPointsHelper::checkRuleEnabled( 'sysplgaup_becomepublisher' );
					if ( $changelevel1 ) {
						if ( $currenttotalpoints>=$changelevel3[0]->points ) {
							// Ready for change level
							$messageChangeLevel = sprintf(JText::_( 'AUP_YOUHAVESUFFICIENTPOINTSBECOME'), JText::_( 'AUP_PUBLISHER' ));
						}
					}
					break;
				
			}
			
			$currentrequests = $model2->_getCurrentRequests( $user->id, $user->gid );
			
		}		
						
		$view->assign('params', $params );
		$view->assign('referreid', $referrerid );
		$view->assign('currenttotalpoints', $currenttotalpoints );
		$view->assign('rowslastpoints', $_listing_last_points );		
		$view->assign('lastupdate', $lastupdate );		
		$view->assign('referraluser', $referraluser );
		$view->assign('referralname', $referralname );
		$view->assign('rowsreferrees', $rowsreferrees );	
		$view->assign('messageChangeLevel', $messageChangeLevel );
		$view->assign('currentrequests', $currentrequests );
		$view->assign('userid', $user->id);
		$view->assign('gid', $user->gid);
		
		// Display
		$view->_display();
	}
	
	
	function requesttochangelevel() {
		global $mainframe;
		
		$model      = &$this->getModel ( 'alphauserpoints' );
		$model2      = &$this->getModel ( 'currentrequests' );
		
		// check referre ID
		$referrerid = $model->_checkUser();
		
		$model2->_setNewRequest();		
		
		return $this->account();
	}
	
	
	function users() {
		global $mainframe;
		
		$model        = &$this->getModel ( 'alphauserpoints' );
		$view         = $this->getView  ( 'users','html' );
		
		$result = $model->_getUsersList();
		
		// Get the parameters of the active menu item
		$params = $model->_getParamsAUP();
				
		$view->assign('params', $params );
		$view->assign('rows', $result[0] );
		$view->assign('total', $result[1] );
		$view->assign('limit', $result[2] );
		$view->assign('limitstart', $result[3] );
		$view->assign('lists', $result[4] );
		
		// Display
		$view->_display();

	}
	
	function invite () {
		global $mainframe;
		
		// active user
		$user = & JFactory::getUser();		
				
		if ( $user->id ) {		
			$user_name = $user->name;			
		} else $user_name = "";	
		
		$model      = &$this->getModel ( 'alphauserpoints' );
		$view       = $this->getView  ( 'invite','html' );		
		
		$referrerid = $model->_getReferreid();
		
		$params = $model->_getParamsAUP();
		
		$view->assign('params', $params );
		$view->assign('user_name', $user_name );
		$view->assign('referreid', $referrerid );		
		
		// Display
		$view->_display();
	
	}
	
	function sendinvite () {
		global $mainframe;
				
		// active user
		$user = & JFactory::getUser();		
		
		$db	=& JFactory::getDBO();

		jimport( 'joomla.mail.helper' );
		
		$model      = &$this->getModel ( 'alphauserpoints' );
		$view       = $this->getView  ( 'invite','html' );		

		$SiteName 	= $mainframe->getCfg('sitename');
		$MailFrom 	= $mainframe->getCfg('mailfrom');
		$FromName 	= $mainframe->getCfg('fromname');

		$uri        =& JURI::getInstance();
		$base    	= $uri->toString( array('scheme', 'host', 'port'));		
		
		$params = $model->_getParamsAUP();
		
		$referrerid = $model->_getReferreid();
		
		// prepare link for register
		$referrer_exist  = ( $referrerid ) ? "&referrer=$referrerid" : "";
		$link    	= $base.JRoute::_( "index.php?option=com_user&task=register$referrer_exist" );		
		
		if ( $params->get( 'userecaptcha' ) ) {				
			require_once (JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'assets'.DS.'recaptcha'.DS.'recaptchalib.php');	
			$privatekey = $params->get( 'privkey' );
			
			// the response from reCAPTCHA
			$resp = null;
			// the error code from reCAPTCHA, if any
			$error = null;
			
			// was there a reCAPTCHA response?
			if ($_POST["recaptcha_response_field"]) {
					$resp = recaptcha_check_answer ($privatekey,
													$_SERVER["REMOTE_ADDR"],
													$_POST["recaptcha_challenge_field"],
													$_POST["recaptcha_response_field"]);
			
					if (!$resp->is_valid) {
						// set the error code so that we can display it
						$error = $resp->error;
						JError::raiseWarning(0, $error );
						return $this->invite ();
					}
			}

		}

		// An array of e-mail headers we do not want to allow as input
		$headers = array (	'Content-Type:',
							'MIME-Version:',
							'Content-Transfer-Encoding:',
							'bcc:',
							'cc:');

		// An array of the input fields to scan for injected headers
		$fields = array ('mailto',
						 'sender',
						 'from',
						 'subject',
						 );

		/*
		 * Here is the meat and potatoes of the header injection test.  We
		 * iterate over the array of form input and check for header strings.
		 * If we fine one, send an unauthorized header and die.
		 */
		foreach ($fields as $field)
		{
			foreach ($headers as $header)
			{
				if (strpos($_POST[$field], $header) !== false)
				{
					JError::raiseError(403, '');
				}
			}
		}

		/*
		 * Free up memory
		 */
		unset ($headers, $fields);
		
		$imported_emails	= $_POST['importedemails'];
		$other_emails		= JRequest::getString('other_recipients', '', 'post');
		$sender 			= JRequest::getString('sender', '', 'post');
		$custommessage		= JRequest::getString('custommessage', '', 'post');
		
		$subject		 	= JText::_( 'AUP_YOUAREINVITEDTOREGISTERON' ) . " " . $SiteName;
		
		// Check for a valid to address
		$errorMail	= false;		
				
		// build list emails
		if($imported_emails=='' && $other_emails!='') {
			$emails = $other_emails;
		} elseif($other_emails=='' && $imported_emails!='') {
			$emails = $imported_emails;
		} elseif ( $imported_emails!='' && $other_emails!='') {
			$emails = $imported_emails . "," . $other_emails;
		} else {
			$emails = "";
			$errorMail	=  JText::_( 'AUP_EMAIL_INVALID' );
			JError::raiseWarning(0, $errorMail );
		}
	
		$emails = @explode( ',', $emails );

		// Check for a valid from address
		if ( ! $MailFrom || ! JMailHelper::isEmailAddress($MailFrom) )
		{
			$errorMail	= JText::sprintf('AUP_EMAIL_INVALID', $MailFrom);
			JError::raiseWarning(0, $errorMail );
		}

		if ( $errorMail ) return $this->invite ();

		// Build the message to send
		$msg	= JText :: _('AUP_EMAIL_MSG_INVITE');
		$body	= sprintf( $msg, $SiteName, $sender, $link) . " \n" . $custommessage;

		// Clean the email data
		$subject = JMailHelper::cleanSubject($subject);
		$body	 = JMailHelper::cleanBody($body);
				
		require_once (JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php');		
		
		// Limit
		$max 		= $params->get( 'maxemailperinvite'   );
		$maxperday  = $params->get( 'maxinvitesperday'    );
		$delay 		= intval($params->get( 'delaybetweeninvites' ));
		
		$counter 	= 0;
		
		$rule_ID = $model->_getRuleID ( 'sysplgaup_invite' );
		
		$currentmaxperday = $model->_checkCurrentMaxPerDay( $rule_ID, $user->id, $referrerid, $_SERVER["REMOTE_ADDR"] );
		
		$checkdelay = 1;
		if ( $delay ) {
			$checkdelay = $model->_checkLastInviteForDelay( $rule_ID, $user->id, $referrerid, $_SERVER["REMOTE_ADDR"], $delay );
		}
		
		if ( !$checkdelay ) {
			$errorTime = JText :: _('AUP_DELAY_BETWEEN_INVITES_INVALID');
			JError::raiseWarning(0, $errorTime );
			return $this->invite ();
		} 
				
		if ( $currentmaxperday < $maxperday ) {
			foreach ($emails as $email) {
				$aEmails[0] = $model->_extractEmailsFromString($email);
				$email= $aEmails[0][0];
				if ( JMailHelper::isEmailAddress($email) ) {
					$mailer =& JFactory::getMailer();
					$mailer->setSender( array( $MailFrom, $FromName ) );
					$mailer->setSubject( $subject);
					$mailer->setBody($body);
					$mailer->addRecipient( $email );					
					if ( $mailer->Send() === true ) {
						if ( $user->id ) {				
							if ( AlphaUserPointsHelper::checkRuleEnabled('sysplgaup_invite') ) {						
								// insert email for tracking
								AlphaUserPointsHelper::userpoints( 'sysplgaup_invite', '', 0, $email, $email  );
							}
						} else {
							// guest user : Insert IP and email for future tracking
							AlphaUserPointsHelper::insertUserPoints( 'GUEST', 1, '', $rule_ID, 0, $_SERVER["REMOTE_ADDR"].' - '.$email, $email );
						}
						$counter++;
						$currentmaxperday++;
					}
					if ( $counter==$max || $currentmaxperday==$maxperday )	break;
				}
			}		
		} else {
			$maxperdaylimit = JText :: _('AUP_MAXINVITESPERDAY') . " " . $maxperday ;
			JError::raiseWarning(0, $maxperdaylimit );
			return $this->invite ();							
		}	
		
		$view->assign('params', $params );
			
		// Display
		$view->_display_sent( $counter );
	}
	
}
?>