<?php
/*
 * @component AlphaUserPoints
 * @copyright Copyright (C) 2008 Bernard Gilly
 * @license : GNU/GPL
 * @Website : http://www.alphaplug.com
 */
defined('_JEXEC') or die('Restricted access');

if(!defined("_ALPHAUSERPOINTS_WARNING_CONGRATULATION"))
{
   DEFINE( "_ALPHAUSERPOINTS_WARNING_CONGRATULATION", 1 );		  
}

class AlphaUserPointsHelper 
{

	function newpoints ( $plugin_function='', $referrerid='', $keyreference='', $datareference='', $randompoints=0, $feedback=false ) 
	{		
		if ( $plugin_function!='' ) 
		{
			AlphaUserPointsHelper::userpoints ( $plugin_function , $referrerid, 0, $keyreference, $datareference, $randompoints, $feedback );
		} 
		else 
		{
			return;	
		}	
	}	
	
	function userpoints ( $plugin_function , $referrerid='', $referraluserpoints=0, $keyreference='', $datareference='', $randompoints=0, $feedback=false ) 
	{	
		$checkReference = 0;
		$force = 0;
		if ( $plugin_function=='sysplgaup_recommend' && $referrerid!='' && $keyreference!='' && $datareference!='' ) 
		{
			$force = 1;		
		}		
		if ( !$referraluserpoints ) 
		{
			if ( !$referrerid ) 
			{
				$referrerid = @$_SESSION['referrerid'];
			}
		}
		if ( !$referrerid ) return;		
		if ( AlphaUserPointsHelper::checkExcludeUsers( $referrerid) ) return ;		
		$result = AlphaUserPointsHelper::checkRuleEnabled( $plugin_function, $force );
		// check reference if not exist
		if ( $keyreference!='' ) $checkReference = AlphaUserPointsHelper::checkReference( $referrerid, $keyreference );		
		if ( $result && !$checkReference ) 
		{
			// force specific points -> overwriting rule points or if rule points is 0
			// This points can be negative (example : only 1 rule in backend for several products on frontend, each products with different prices...)
			if ( $randompoints ) $result[0]->points = $randompoints;
			if ( AlphaUserPointsHelper::operationIsFeasible ( $referrerid, $result[0]->points ) )
			{
				// check account
				AlphaUserPointsHelper::insertUserPoints( $referrerid, $result[0]->points, $result[0]->rule_expire, $result[0]->id, $referraluserpoints, $keyreference, $datareference, $result[0]->autoapproved, $result[0]->plugin_function );
				if ( $feedback ) return true;
			}
			else
			{
				// used for negative operation, 
				// $mainframe->enqueueMessage( JText::_('AUP_YOUDONOTHAVEENOUGHPOINTSTOPERFORMTHISOPERATION'), 'alert' );
				$error = JText::_('AUP_YOUDONOTHAVEENOUGHPOINTSTOPERFORMTHISOPERATION');
				JError::raiseNotice(0, $error );
				if ( $feedback ) 
				{
					return false;
				} 
				else
				{
					return;
				}
			}
		}	
	}

	function insertUserPoints( $referrerid, $points, $rule_expire='0000-00-00 00:00:00', $rule_id, $referraluserpoints=0, $keyreference='', $datareference='', $autoapproved='1', $rule_plugin='' ) 
	{
		if ( !$referrerid || $points==0 ) return;
		$jnow		=& JFactory::getDate();
		$now		= $jnow->toMySQL();		
		$points = ( $referraluserpoints>=1 ) ? $referraluserpoints : $points ;	
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_alphauserpoints'.DS.'tables');		
		// save new points into alpha_userpointsdetails table
		$row =& JTable::getInstance('userspointsdetails');
		$row->id				= NULL;
		$row->referreid			= $referrerid;
		$row->points			= $points;
		$row->insert_date		= $now;
		$row->expire_date 		= $rule_expire;		
		$row->rule				= $rule_id;
		$row->approved			= $autoapproved;
		$row->status			= $autoapproved;
		$row->keyreference		= $keyreference;
		$row->datareference		= $datareference;
		if ( !$row->store() ) 
		{
			JError::raiseError(500, $row->getError());
		}	
		if ( $referrerid!='GUEST' && $autoapproved || $referraluserpoints>0 ) 
		{
			AlphaUserPointsHelper::updateUserPoints( $referrerid, $points, $now, $referraluserpoints, $autoapproved, $rule_plugin );		
		}
	}

	function updateUserPoints( $referrerid, $assignpoints, $now, $referraluserpoints, $autoapproved, $rule_plugin='' ) 
	{
		global $mainframe;
		JPlugin::loadLanguage( 'com_alphauserpoints' );	
		$db	   =& JFactory::getDBO();	
		$query = "SELECT id FROM #__alpha_userpoints WHERE `referreid`='$referrerid'";
		$db->setQuery( $query );
		$referrerUser = $db->loadResult();
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_alphauserpoints'.DS.'tables');				
		$row =& JTable::getInstance('userspoints');		
		// update points into alpha_userpoints table
		$row->load( intval($referrerUser) );		
		$referraluser = $row->referraluser;		
		$newtotal = ( !$referraluserpoints ) ? ($row->points + $assignpoints) : $row->points + $referraluserpoints ;		
		$row->last_update = $now;	
		$checkWinner = 0;		
		if ( $row->max_points >=1 && ( $newtotal > $row->max_points ) ) 
		{
			// Max total was reached !
			$newtotal = $row->max_points;
			// HERE YOU CAN ADD MORE FUNCTIONS! example call other component etc...
			if ( AlphaUserPointsHelper::checkRuleEnabled( 'sysplgaup_winnernotification' ) ) 
			{
				// get email admins in rule
				$query = "SELECT `content_items` FROM #__alpha_userpoints_rules WHERE `plugin_function`='sysplgaup_winnernotification'";
				$db->setQuery( $query );
				$emailadmins = $db->loadResult();
				if ( $autoapproved || $referraluserpoints )
				{
					AlphaUserPointsHelper::sendwinnernotification ( $referrerid, $assignpoints, $newtotal, $emailadmins );				
					$checkWinner = 1;
				}
			}
		}								
		$row->points = $newtotal;
		if ( $autoapproved )  {
			if ( $rule_plugin=='sysplgaup_invitewithsuccess' ) $row->referrees = $row->referrees+1;		
			$db->updateObject( '#__alpha_userpoints', $row, 'id' );
			if ( _ALPHAUSERPOINTS_WARNING_CONGRATULATION && !$referraluserpoints )
			{
				switch ( $rule_plugin )
				{
					case 'sysplgaup_user2userpoints':
					case 'sysplgaup_bonuspoints':	
					case 'sysplgaup_recommend':	
					case 'sysplgaup_reader2author':									
						break;
					case 'sysplgaup_invitewithsuccess':
						// number points in message = assign points to new user
						$numpoints = AlphaUserPointsHelper::getPointsRule( 'sysplgaup_newregistered' );
						if ( $numpoints ) $mainframe->enqueueMessage( sprintf ( JText::_('AUP_CONGRATULATION'), $numpoints ));
						break;
					
					default:
						$mainframe->enqueueMessage( sprintf ( JText::_('AUP_CONGRATULATION'), $assignpoints ) );
				}
			}
		}		
		if ( AlphaUserPointsHelper::checkRuleEnabled( 'sysplgaup_emailnotification' ) && !$checkWinner )
		{
			AlphaUserPointsHelper::sendnotification ( $referrerid, $assignpoints, $newtotal );
		}
		// referral points rule
		if ( $referraluserpoints==0 && $referraluser!='' )
		{ // if not already assign
			$query = "SELECT * FROM #__alpha_userpoints_rules WHERE `plugin_function`='sysplgaup_referralpoints' AND `published`='1' AND (`rule_expire`>'$now' OR `rule_expire`='0000-00-00 00:00:00')";
			$db->setQuery( $query );
			$referralpoints = $db->loadObjectList();			
			if ( $referralpoints )
			{
				$referraluserpoints = round(($assignpoints*$referralpoints[0]->points)/100) ;
				if ( $referraluserpoints>=1 ) AlphaUserPointsHelper::userpoints( 'sysplgaup_referralpoints', $referraluser, $referraluserpoints );			
			}
		}
	}
	
	function getPointsRule( $plugin_function )
	{
		$db	        =& JFactory::getDBO();
		$query = "SELECT `points` FROM #__alpha_userpoints_rules WHERE `plugin_function`='$plugin_function'";
		$db->setQuery( $query );
		$numpoints = $db->loadResult();
		return	$numpoints;	
	}
	
	function reader2author ( $authorid=0, $articleid=0 )
	{	
		if ( !$authorid || !$articleid ) return;		
		if ( AlphaUserPointsHelper::checkExcludeUsers( $authorid ) ) return ;	
		$ip = getenv('REMOTE_ADDR');		
		$db	        =& JFactory::getDBO();			
		// check if not already view by active user
		$query = "SELECT `id` FROM #__alpha_userpoints_details WHERE `keyreference`='$articleid' AND `datareference`='$ip'";
		$db->setQuery( $query );
		$alreadyView = $db->loadResult();
		if ( !$alreadyView )
		{	
			$user = & JFactory::getUser();			
			$jnow		=& JFactory::getDate();
			$now		= $jnow->toMySQL();					
			$query = "SELECT * FROM #__alpha_userpoints_rules WHERE `plugin_function`='sysplgaup_reader2author' AND `published`='1' AND `access`<='" . (int) $user->aid . "' AND (`rule_expire`>'$now' OR `rule_expire`='0000-00-00 00:00:00')";
			$db->setQuery( $query );
			$result  = $db->loadObjectList();			
			if ( $result )
			{
				// get referrerid of author
				$referrerUserAuthor = AlphaUserPointsHelper::getAnyUserReferreID( $authorid );
				if ($referrerUserAuthor)
				{
					AlphaUserPointsHelper::insertUserPoints( $referrerUserAuthor, $result[0]->points, $result[0]->rule_expire, $result[0]->id, 0, $articleid, $ip, $result[0]->autoapproved, $result[0]->plugin_function );					
				}
			}
		}
	}
	
	function checkExcludeUsers($referreID)
	{	
		$db	   =& JFactory::getDBO();			
		$excludeuser = array();		
		$query = "SELECT exclude_items FROM #__alpha_userpoints_rules WHERE `plugin_function`='sysplgaup_excludeusers' AND `published`='1'";
		$db->setQuery( $query );
		$result  = $db->loadResult();		
		if ( $result )
		{		
			$excludeuser = explode( ",", $result);
			if ( in_array( $referreID, $excludeuser ) )
			{
				return true;
			}
		}
		return false;
	}
	
	function checkRuleEnabled( $plugin_function='', $force=0 )
	{	
		$user = & JFactory::getUser();	
		if ( !$plugin_function ) return false;	
		$jnow		=& JFactory::getDate();
		$now		= $jnow->toMySQL();
		$accessrule = "";			
		switch ( $plugin_function )
		{		
			case 'sysplgaup_referralpoints': // assign to all referral users level	
			case 'sysplgaup_excludeusers':   // enabled this rule for all users level
			case 'sysplgaup_emailnotification':
			case 'sysplgaup_winnernotification':
			case 'sysplgaup_newregistered':
			case 'sysplgaup_invitewithsuccess':			
				$accessrule = "";				
				break;
			case 'sysplgaup_recommend':
				if ( $force )
				{
					$accessrule = "";	
				} else $accessrule = "AND `access`<='" . (int) $user->aid . "'";					
				break;
			default:
				$accessrule = "AND `access`<='" . (int) $user->aid . "'";
				break;		
		}		
		$db	   =& JFactory::getDBO();		
		$query = "SELECT * FROM #__alpha_userpoints_rules WHERE `plugin_function`='$plugin_function' AND `published`='1' $accessrule AND (`rule_expire`>'$now' OR `rule_expire`='0000-00-00 00:00:00')";
		$db->setQuery( $query );
		$result  = $db->loadObjectList();
		return $result;	
	}
	
	function checkReference( $referrerid, $keyreference )
	{	
		$db	   =& JFactory::getDBO();		
		$query = "SELECT count(*) FROM #__alpha_userpoints_details WHERE `referreid`='$referrerid' AND `keyreference`='$keyreference'";
		$db->setQuery( $query );
		$resultKeyReference = $db->loadResult();
		return $resultKeyReference;	
	}
	
	function getReferreid( $userID )
	{	
		if ( !$userID ) return;	
		// get referre ID on login	
		$db	   =& JFactory::getDBO();
		$query = "SELECT referreid FROM #__alpha_userpoints WHERE `userid`='$userID'";
		$db->setQuery( $query );
		$referreid = $db->loadResult();		
		if ( $referreid )
		{		
			@session_start('alphauserpoints');	
			$_SESSION['referrerid'] = $referreid;
		}	
	}
	
	function getAnyUserReferreID( $userID )
	{	
		// get referre ID for an author etc...
		$db	   =& JFactory::getDBO();
		$query = "SELECT referreid FROM #__alpha_userpoints WHERE `userid`='".intval($userID)."'";
		$db->setQuery( $query );
		$referreid = $db->loadResult();		
		return  $referreid;		
	}
	
	function getUserInfo ( $referrerid='' )
	{	
		if ( !$referrerid ) return;	
		$db	   =& JFactory::getDBO();		
		$query = "SELECT a.*, u.* FROM #__alpha_userpoints AS a, #__users AS u WHERE a.referreid='$referrerid' AND a.userid=u.id";
		$db->setQuery( $query );
		$userinfo = $db->loadObjectList();	
		return @$userinfo[0];	
	}
	
	function sendnotification ( $referrerid, $assignpoints, $newtotal )
	{
		global $mainframe;		
		if ( !$referrerid || $referrerid=='GUEST') return;		
		$MailFrom	= $mainframe->getCfg('mailfrom'); 	
		$FromName	= $mainframe->getCfg('fromname'); 
		$SiteName	= $mainframe->getCfg('sitename');			
		$userinfo = AlphaUserPointsHelper::getUserInfo( $referrerid );		
		$email	  = $userinfo->email;		
		if ( !$userinfo->block )
		{		
			$subject = JText::_('AUP_EMAILNOTIFICATION_SUBJECT');
			$message = sprintf ( JText::_('AUP_EMAILNOTIFICATION_MSG'), $SiteName, $assignpoints, $newtotal );	
			JUtility::sendMail( $MailFrom, $FromName, $email, $subject, $message );
		}		
	}
	
	function sendwinnernotification ( $referrerid, $assignpoints, $newtotal, $emailadmins='' )
	{
		global $mainframe;		
		if ( !$referrerid || $referrerid=='GUEST') return;		
		$MailFrom	= $mainframe->getCfg('mailfrom'); 	
		$FromName	= $mainframe->getCfg('fromname');		
		$userinfo 	= AlphaUserPointsHelper::getUserInfo( $referrerid );
		$name 		= $userinfo->name;
		$email	 	= $userinfo->email;
		if ( !$userinfo->block )
		{				
			// send notification to winner
			$subject = JText::_('AUP_EMAILWINNERNOTIFICATION_SUBJECT_MSG_USER');
			$message = sprintf ( JText::_('AUP_EMAILWINNERNOTIFICATION_MSG_USER'), $name, $newtotal );			
			JUtility::sendMail( $MailFrom, $FromName, $email, $subject, $message );			
			// send notification to administrators...		
			if ( $emailadmins )
			{
				$subject = JText::_('AUP_EMAILWINNERNOTIFICATION_SUBJECT_MSG_ADMIN');
				$message = sprintf ( JText::_('AUP_EMAILWINNERNOTIFICATION_MSG_ADMIN'), $name, $newtotal );				
				JUtility::sendMail( $MailFrom, $FromName, $emailadmins, $subject, $message );
			}
		}
	
	}

	function getCurrentTotalPoints ( $referreid='' )
	{	
		if ( !$referreid ) return;	
		$db	   =& JFactory::getDBO();	
		$query = "SELECT points FROM #__alpha_userpoints WHERE `referreid`='".$referreid."' AND `blocked`='0'";
		$db->setQuery( $query );
		$currenttotalpoints = $db->loadResult();
		return $currenttotalpoints;		
	}
	
	function operationIsFeasible ( $referreid='', $numpoints )
	{
		if ( !$referreid ) return;
		$currentpoints = AlphaUserPointsHelper::getCurrentTotalPoints ( $referreid );
		$newtotal = $currentpoints + $numpoints;
		if ( $newtotal >=0 ) 
		{
			return true;
		}
		else
		{
			return false;
		}	
	}
}
?>